open simplified_rma

/*
		T1:						T2:
	remotePut(Y, 1)	remotePut(X, 2)
	flush						flush
	read X					read Y
*/

/*
	Observation: the final flush statements have to be added
		because else the read x and read y statements are in 
		a data race
*/

pred program1 [] {
	/* program */
	some disj rx, ry: Read, disj wx, wy: RemotePut, disj f1, f2:Flush, disj t1, t2: Thread, disj x, y: MemoryLocation | 
		/* thread 1 */
		o[rx] = t1 and o[wy] = t1 and o[f1] = t1 and
		d[wy] = t2 and d[f1] = t2 and d[rx] = t1 and
		f1 in wy.po and rx in f1.po
		and wy.wl = y and rx.rl = x 
		and wy.V = 1 and

		/* thread 2 */
		d[wx] = t1 and d[f2] = t1 and d[ry] = t2 and 
		o[ry] = t2 and o[wx] = t2 and o[f2] = t2 and
		f2 in wx.po and ry in f2.po
		and wx.wl = x and ry.rl = y 
		and wx.V = 2

		/* spec */
		//and V[rx] = 2 and V[ry] = 1


		and #Item = 8
}

run program1 for 18
