import java.util.List;
import java.util.ArrayList;

public class FirstPortalsVisitor extends TLBaseVisitor<Object> {
    InstanceValue result;
    StringBuilder simpleExpressionBuffer;

    Proc currentProc;

    public FirstPortalsVisitor(InstanceValue result) {
        this.result = result;
        simpleExpressionBuffer = new StringBuilder();
    }

    @Override
    public Object visitProcess(TLParser.ProcessContext ctx) {
        int procNumber = Integer.parseInt(ctx.Number().getText());
        this.currentProc = new Proc(procNumber);
        result.processes.add(this.currentProc);
        result.processContents.put(procNumber, new ArrayList<>());
        result.mdEventCounts.put(procNumber, 0);
        result.leEventCounts.put(procNumber, 0);

        visitChildren(ctx);
        return null;
    }
}
