open micro_rma

pred dekker [] {

some  disj it0, if0, if1, ilf1, ilf2, ilt1, ilt1s, ilf2s: InitialValue,
		  disj wf00, rgts, vrts, vwts,
		  			vrt, vwt, rgt,
		 		 	rgf1s, vrf1s, vwf1s,
		  			wf10, rts, wf11s, 
		  			rt, rgf0s, vrf0s, vwf0s,
					rlt1, rlt1s,
					rlf2s: Item,
		  disj wf01, wf01s, wf11: AtomicWrite, 
		  disj rlf1, rlf2: AtomicRead,
		  disj vrf1, vrf0: AVirtualRead,
		  disj vwf1, vwf0: AVirtualWrite,
		  disj rgf1, rgf0: RemoteGet,
		  disj  flush1, flush2, flush3, flush4 :Item, 
		  disj  vflush1, vflush2, vflush3, vflush4 :Item, 
		  disj t1, t2: Thread, 
		  disj f0, f1, t, lf1, lf1s, lt1, lt1s, lf2, lf2s: MemoryLocation | 


/* f0 = 0 */
	o[if0] = t1 and d[if0] = t1 and wl[if0] = f0 and V[if0] = 0 and

	o[ilf1] = t1 and d[ilf1] = t1 and wl[ilf1] = lf1 and V[ilf1] = 0 and

	o[ilt1] = t1 and d[ilt1] = t1 and wl[ilt1] = lt1 and V[ilt1] = 0 and

	o[ilt1s] = t1 and d[ilt1s] = t1 and wl[ilt1s] = lt1s and V[ilt1s] = 0 and

/* T0:
  flag0 = 1; */
	o[wf01] = t1 and d[wf01] = t1 and wl[wf01] = f0 and V[wf01] = 1 and 

/*  lf1 = RemoteGet(flag1) */
	o[rgf1] = t1 and d[rgf1] = t2 and rgf1 in po[wf01] and

	trigger[vrf1] = rgf1 and rl[vrf1] = f1 and d[vrf1] = t2 and
	trigger[vwf1] = rgf1 and wl[vwf1] = lf1 and d[vwf1] = t1 and

/* flush */
	o[flush1] = t1 and d[flush1] = t2 and flush1 in po[rgf1] and triggerFlush[vflush1] = flush1 and

/*  if (lf1 == 1) */
	o[rlf1] = t1 and d[rlf1] = t1 and rl[rlf1] = lf1 and rlf1 in po[flush1] and
	((rV[rlf1] = 1) implies (
	rgt in RemoteGet and
	vrt in AVirtualRead and
	vwt in AVirtualWrite and
	rgf1s in RemoteGet and
	vrf1s in AVirtualRead and
	vwf1s in AVirtualWrite and
	flush2 in Flush and
	vflush2 in VirtualFlush and

	rlt1 in AtomicRead and

/*    lt1 = RemoteGet(turn);  */
	o[rgt] = t1 and d[rgt] = t2 and rgt in po[flush1] and

	trigger[vrt] = rgt and rl[vrt] = t and d[vrt] = t2 and
	trigger[vwt] = rgt and wl[vwt] = lt1 and d[vwt] = t1 and

/* flush */
	o[flush2] = t1 and d[flush2] = t2 and flush2 in po[rgt] and triggerFlush[vflush2] = flush2 and


/*    if (lt1 == 1) then   */
	o[rlt1] =  t1 and d[rlt1] = t1 and rl[rlt1] = lt1 and rlt1 in po[flush2] and
	((rV[rlt1] = 1) implies (

	wf00 in AtomicWrite and
	rgts in RemoteGet and
	vrts in AVirtualRead and
	vwts in AVirtualWrite and
	wf01s in AtomicWrite and
	flush3 in Flush and
	vflush3 in VirtualFlush and 

	rlt1s in AtomicRead and

/*  flag0 = 0;  */
	o[wf00] = t1 and d[wf00] = t1 and wl[wf00] = f0 and V[wf00] = 0 and wf00 in po[flush2] and

/*    lt1s = RemoteGet(turn) */
	o[rgts] = t1 and d[rgts] = t2 and rgts in po[wf00] and

	trigger[vrts] = rgts and rl[vrts] = t and d[vrts] = t2 and
	trigger[vwts] = rgts and wl[vwts] = lt1s and d[vwts] = t1 and

/* flush */
	o[flush3] = t1 and d[flush3] = t2 and flush3 in po[rgts] and triggerFlush[vflush3] = flush3 and

/* assume (lt1s == 1) */
	o[rlt1s] = t1 and d[rlt1s] = t1 and rl[rlt1s] = lt1s and rlt1s in po[flush3] and
	(rV[rlt1s] = 1 or rV[rlt1s] = Top) and 

/*   flag0 = 1 */
	o[wf01s] = t1 and d[wf01s] = t1 and wl[wf01s] = f0 and V[wf01] = 1 and wf01s in po[flush3] and
	rgf1s in po[wf01s])) and

	(not (rV[rlt1] = 1) implies (
		not wf00 in Action and
		not rgts in Action and
		not vrts in Action and
		not vwts in Action and
		not wf01s in Action and

		not rlt1s in Action and

		not flush3 in Action and
		not vflush3 in Action and
		rgf1s in po[flush2]))

	and

/* lf1s= RemoteGet(flag1) */
	o[rgf1s] = t1 and d[rgf1s] = t2 and

	trigger[vrf1s] = rgf1s and rl[vrf1s] = f1 and d[vrf1s] = t2 and
	trigger[vwf1s] = rgf1s and wl[vwf1s] = lf1s and d[vwf1s] = t1 and

/*	assume(lf1s == 1) */
	wV[vwf1s] = 1)) and

/*    endif;  */
	(not (rV[rlf1] = 1) implies ( 
		not rgt in Action and 
		not vrt in Action and 
		not vwt in Action and

		not rlt1 in AtomicRead and
		not rlt1s in AtomicRead and

		not wf00 in Action and
		not wf01s in Action and

		not rgts in Action and
		not vrts in Action and
		not vwts in Action and

		not rgf1s in Action and
		not vrf1s in Action and
		not vwf1s in Action and
 
		not flush2 in Action and
		not flush3 in Action and
		not vflush2 in Action and
		not vflush3 in Action)) and

/*   -- Critical Section -- */

/* ================= */

/* T1:
  f1 == 0 */
	o[if1] = t2 and d[if1] = t2 and wl[if1] = f1 and V[if1] = 0 and

	o[ilf2] = t2 and d[ilf2] = t2 and wl[ilf2] = lf2 and V[ilf2] = 0 and

	o[ilf2s] = t2 and d[ilf2s] = t2 and wl[ilf2s] = lf2s and V[ilf2s] = 0 and

/* t = 0 */
	o[it0] = t2 and d[it0] = t2 and wl[it0] = t and V[it0] = 0  and 

/*  f1 = 1;  */
	o[wf11] = t2 and d[wf11] = t2 and wl[wf11] = f1 and V[wf11] = 1 and

/*  lf2 = RemoteGet (f0)  */
	o[rgf0] = t2 and d[rgf0] = t1 and rgf0 in po[wf11] and

	trigger[vrf0] = rgf0 and rl[vrf0] = f0 and d[vrf0] = t1 and
	trigger[vwf0] = rgf0 and wl[vwf0] = lf2 and d[vwf0] = t2 and

/* flush */
	o[flush4] = t2 and d[flush4] = t1 and flush4 in po[rgf0] and triggerFlush[vflush4] = flush4 and


/*  if (lf2 == 1) */
	o[rlf2] = t2 and d[rlf2] = t2 and rl[rlf2] = lf2 and rlf2 in po[flush4] and
	((rV[rlf2] = 1) implies (
	rt in AtomicRead and
	rgf0s in RemoteGet and
	vrf0s in AVirtualRead and
	vwf0s in AVirtualWrite and 

/*    t2 = t;  */
	o[rt] = t2 and d[rt] = t2 and rl[rt] = t and rt in po[flush4] and

/* if (t2 == 0) then */

	((rV[rt] = 0) implies (

	wf10 in AtomicWrite and
	rts in AtomicRead and
	wf11s in AtomicWrite and
	rlf2s in AtomicRead and

/*  flag1 = 0;  */
	o[wf10] = t2 and d[wf10] = t2 and wl[wf10] = f1 and V[wf10] = 0 and wf10 in po[rt] and

/*    t2 = turn */
	o[rts] = t2 and d[rts] = t2 and rl[rts] = t and rts in po[wf10] and

/*	assume (t2 == 1) */
	rV[rts] = 1 and 

/* flag1 = 1; */
	o[wf11s] = t2 and d[wf11s] = t2 and wl[wf11s] = f1 and V[wf11s] = 1 and wf11s in po[rts] and

	rgf0s in po[wf11s] )) and
/*    endif; */

	(not (rV[rt] = 0) implies (

		not wf10 in Action and
		not rts in Action and
		not wf11s in Action and
		rgf0s in po[rt])) and

/* f2 = RemoteGet (flag0); */
	o[rgf0s] = t2 and d[rgf0s] = t1 and

	trigger[vrf0s] = rgf0s and rl[vrf0s] = f0 and d[vrf0s] = t1 and
	trigger[vwf0s] = rgf0s and wl[vwf0s] = lf2s and d[vwf0s] = t2 and
/* assume(f2 == 1) */
	o[rlf2s] = t2 and d[rlf2s] = t2 and rl[rlf2s] = lf2s and rlf2s in po[rgf0s] and
	rV[rlf2s] = 1 )) and

	(not (rV[rlf2] = 1) implies (
		not rt in Action and
		not wf10 in Action and
		not rts in Action and
		not wf11s in Action and
		not rgf0s in Action and
		not vrf0s in Action and
		not vwf0s in Action and

		not rlf2s in Action)) 

	and

/*  -- Critical Section -- */
	#Item = 47
}

run dekker for 47
