open generate_litmus_time as m

/* There should be at least one local read from each writer (except initial values)*/
fact {W[Read] = Writer - InitialValue}

/* ReaderPivot is always a local Read */
fact { ReaderPivot in Read and Witness = ReaderPivot }

/* Properties of the test */
pred show { //#Thr = 2 and
            //#(Action.o) > 1 and
            #Rcas = 0 and
            #Rga = 1 and
            Robust.no_conflicts = True }

run show for 8
