#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <pthread.h>
#include <sys/select.h>

struct arg_server {
  FILE * f;
  char * n;
};

void * echo (void * a) {
  struct arg_server *arg = (struct arg_server *)a;
  char in_string[1035];

  while (1) {
    if (fgets(in_string, sizeof(in_string)-1, arg->f) == NULL) {
      break;
    } else {
      printf("[%s] %s", arg->n, in_string);
    }
  }
  return NULL;
}

int main(int argc, char *argv[]) {
  char path[1035], tmp[10];
  static struct arg_server s = { .n = "server" },
    c = { .n = "client" };

    if (argc != 1) {
      printf("usage: %s\n", argv[0]);
      exit(1);
    }

    /* Open the command for reading */
    s.f = popen("./rdma-server", "r");
    if (s.f == NULL) {
      printf("Failed to run %s\n", argv[1]);
      exit(1);
    }

    while (fgets(path, sizeof(path)-1, s.f) != NULL) {
      printf("[server] %s", path);
      break;
    }

    int j = 0;
    for(int i = 0; path[i]; i++) {
      if (path[i] >= '0' && path[i] <= '9') {
	tmp[j] = path[i];
	j++;
      }
    }
    tmp[j] = '\0';
    int port = atoi(tmp);
    fprintf(stdout, "[starter] number is %d\n", port);

    sprintf(path, "%s %s %d", "./rdma-client", "localhost", port);
    c.f = popen(path, "r");

    pthread_t server_poller, client_poller;
    pthread_create(&server_poller, NULL, echo, &s);
    pthread_create(&client_poller, NULL, echo, &c);

    pthread_join(client_poller, NULL);
    pthread_join(server_poller, NULL);

    return 0;
}
