open util/integer

sig Thr { }
sig MemoryLocation { host: one Thr }
one sig Top {}

sig Action { o, d: one Thr }
sig Writer in Action {
    wl: one MemoryLocation,
    wV: one Int
}

abstract sig ExternalAction extends Action {}
abstract sig ExternAction extends ExternalAction {}
sig ExternWrite extends ExternAction {
}

fact { #(Action.o) = 2 and #(Action.d) = 2 }
fact { #MemoryLocation = 2 and #Thr = 2 and #ExternWrite = 1 and #(ExternWrite.wl) = 1 }

pred show {}

run show for 2
